<template>
  <div class="clickable">
        <div v-show="sameValues && !verified">
            <q-chip color="white" text-color="red" dense>{{ props.row[manual] }}</q-chip>
            <q-popup-edit v-model="props.row[manual]" buttons label-set="Save" @save="saveData()" :disable="disable">
              <q-input v-model="props.row[manual]" dense persistent autofocus counter />
            </q-popup-edit>
            <q-menu touch-position context-menu v-show="!disable">
              <q-list dense style="min-width: 100px">
                  <q-item clickable v-close-popup>
                    <q-item-section @click="props.row[manual] = '!'+props.row[auto]; saveData()" >Validate value</q-item-section>
                  </q-item>
                  <q-item clickable v-close-popup>
                    <q-item-section @click="props.row[manual] = '!'; saveData()" >Delete value</q-item-section>
                  </q-item>
              </q-list>
            </q-menu>
            <q-tooltip :delay="300" content-class="bg-grey-1 text-primary">Automatic value</q-tooltip>
        </div>
        <div v-show="sameValues && verified">
            <q-chip color="white" text-color="green" dense>{{ props.row[manual].replace("!","") }}</q-chip>
            <q-popup-edit v-model="props.row[manual]" buttons label-set="Save" @save="saveData()" :disable="disable">
              <q-input v-model="props.row[manual]" dense persistent autofocus counter />
            </q-popup-edit>
            <q-menu touch-position context-menu v-show="!disable">
              <q-list dense style="min-width: 100px">
                  <q-item clickable v-close-popup>
                    <q-item-section @click="props.row[manual] = props.row[auto];saveData()" >Revoke manual changes</q-item-section>
                  </q-item>
              </q-list>
            </q-menu>
            <q-tooltip :delay="300" content-class="bg-grey-1 text-primary">Manual value, Right-click on it to show options.</q-tooltip>
        </div>
        <div v-show="!sameValues">
            <q-chip color="white" text-color="green" dense>{{ props.row[manual].replace("!","") }}<q-badge color="green" outline floating transparent><q-icon name="done" color="green" class="q-ml-xs" /></q-badge></q-chip>
            <q-popup-edit v-model="props.row[manual]" buttons label-set="Save" @save="saveData()" :disable="disable">
              <q-input v-model="props.row[manual]" dense persistent autofocus counter />
            </q-popup-edit>
            <q-menu touch-position context-menu v-show="!disable">
              <q-list dense style="min-width: 100px">
                  <q-item clickable v-close-popup>
                  <q-item-section @click="props.row[manual] = props.row[auto];saveData()" >Revoke manual changes</q-item-section>
                  </q-item>
              </q-list>
            </q-menu>
            <q-tooltip :delay="300" content-class="bg-grey-1 text-primary">Manual value, Right-click on it to show options.</q-tooltip>
        </div>
    </div>
</template>

<script>
// module.exports = {
export default {
  data: function () {
    return {
    }
  },
  props: ['props', 'manual', 'auto', 'parentSaveData', 'disable'],
  computed:{
    verified: function () {
      return this.props.row[this.manual].startsWith("!") ;//|| this.props.row[this.manual] == '! '
    },
    sameValues: function () {
      let man = this.props.row[this.manual].replace("!", "");
      return this.props.row[this.auto] == man;
    }
  },
  methods: {
    saveData(){ this.parentSaveData(this.$props.props.row, this.$props.manual); } // access parent method as prop,
  }
}
</script>

<style scoped>
.clickable {
  cursor:pointer;
}
</style>
